#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdlib.h>
#include "global.h"
#include "uart.h"
#include "rf12.h"  
#include <stdio.h>   

#define F_CPU 12000000UL
#include <util/delay.h>

void send(void);
void receive(void);
void sendOOK();
void bit0(void);
void bit1(void);
void sync(void);

char str[32];



int main(void)
{

    uart_init(UART_BAUD_SELECT(19200, F_CPU));		// just for debugging purposes
	rf12_init();								// ein paar Register setzen (z.B. CLK auf 10MHz)
	rf12_setfreq(RF12FREQ(433.92));				// Sende/Empfangsfrequenz auf 433,92MHz einstellen
	rf12_setbandwidth(4, 1, 4);					// 200kHz Bandbreite, -6dB Verstrkung, DRSSI threshold: -79dBm 
	//xxx rf12_setbaud(19200);					// 19200 baud
	rf12_setbaud(4800);							// 4800 baud
	rf12_setpower(0, 6);						// 1mW Ausgangangsleistung, 120kHz Frequenzshift


	sei();
	uart_puts_P("Sender laeuft !\n");

	rf12_trans(0x8238);		// TX on

	for (;;)
	{
		sendOOK();
	}
}


// not used in sender
void receive(void)
{	unsigned char test[32];	
	rf12_rxdata(test,32);	
	for (unsigned char i=0; i<32; i++)
		uart_putc(test[i]);
}


// not used in OOK-Tests
void send(void)
{	unsigned char test[]="Dies ist ein 433MHz Test !!!\n   ";	//xxx
	rf12_txdata(test,32);										//xxx
	//xxxrf12_txdata(str,32);
}


void sendOOK(void)
{	
	bit0();
	bit0();
	bit0();
	bit1();
	bit1();
	bit0();
	bit0();
	bit1();
	bit1();
	bit1();
	bit0();
	bit0();
	bit1();
	bit1();
	bit0();
	bit0();
	bit1();
	sync();
}


void bit0(void)
{
	rf12_trans(0x8238);			// TX on
	_delay_us(420);
	rf12_trans(0x8208);			// TX off
	_delay_us(840);
}


void bit1(void)
{
	rf12_trans(0x8238);			// TX on
	_delay_us(1630);
	rf12_trans(0x8208);			// TX off
	_delay_us(910);
}


void sync(void)
{;
	rf12_trans(0x8208);			// TX off
	_delay_us(9000);
}
